; input: str1.txt, str2.txt
; output: changed str1.txt containing only characters occurred in str2.txt
; 	the changed str1.txt will also output to screen
	.MODEL	small
	.STACK	100h

	.DATA
exist	DB	100h DUP(0)
file1	DB	"str1.txt",0
file2	DB	"str2.txt",0
err1	DB	"Cannot open str1.txt$"
err2	DB	"Cannot open str2.txt$"
err3	DB	"str1.txt read fail$"
err4	DB	"str2.txt read fail$"
err5	DB	"str1.txt write fail$"
buf	DW	0
readpos	DW	0		; we do not have enough registers

	.CODE
	.STARTUP
	mov	ah, 3dh
	mov	al, 0
	lea	dx, file2
	int	21h		; open file2 for read
	jc	notopen2
	mov	bx, ax		; bx is file handle
	mov	cx, 1
	lea	dx, buf
getch1:
	mov	ah, 3fh
	int	21h
	jc	readfail2
	cmp	ax, 1
	jne	eof1
	mov	di, [buf]
	mov	BYTE PTR [exist+di], 1	; exist[getchar()] = 1
	jmp	getch1
eof1:
	mov	ah, 3eh
	int	21h		; close file2
	mov	ah, 3dh
	mov	al, 2
	lea	dx, file1
	int	21h		; open file1 for read & write
	jc	notopen1
	mov	bx, ax		; bx is file handle
	xor	si, si		; write offset
getch2:
	mov	ah, 42h		; set file pointer to read pos
	xor	al, al		; from file head
	xor	cx, cx		; offset high bits
	mov	dx, [readpos]	; read offset
	int	21h
	jc	writefail
	add	[readpos], 1

	mov	ah, 3fh
	mov	cx, 1
	lea	dx, buf
	int	21h		; read
	jc	readfail1
	cmp	ax, 1
	jne	eof2

	mov	di, [buf]
	cmp	BYTE PTR [exist+di], 1	; exist[getchar()] == 1
	jne	getch2

	mov	ah, 42h		; set file pointer to write pos
	xor	al, al
	xor	cx, cx
	mov	dx, si		; write offset
	int	21h
	jc	writefail
	add	si, 1

	mov	ah, 40h
	mov	cx, 1
	lea	dx, buf
	int	21h		; write existing char to file
	jc	writefail
	mov	ah, 2
	mov	dl, BYTE PTR [buf]
	int	21h		; output to screen
	jmp	getch2
eof2:
	mov	ah, 42h
	xor	al, al
	xor	cx, cx
	mov	dx, si
	int	21h
	jc	writefail
	mov	ah, 40h
	int	21h		; truncate file1 to last write offset
	jc	writefail
	mov	ah, 3eh
	int	21h		; close file1
	jmp	return

notopen1:
	mov	ah, 09h
	lea	dx, err1
	int	21h
	jmp	return
notopen2:
	mov	ah, 09h
	lea	dx, err2
	int	21h
	jmp	return
readfail1:
	mov	ah, 09h
	lea	dx, err3
	int	21h
	jmp	return
readfail2:
	mov	ah, 09h
	lea	dx, err4
	int	21h
	jmp	return
writefail:
	mov	ah, 09h
	lea	dx, err5
	int	21h
	jmp	return
return:
	mov	ax, 4c00h	; return to dos
	int	21h
end
